=== debian/changelog ===
intel-compute-runtime (20.13.16352-1) unstable; urgency=medium

  * New upstream release.
  * control: Use debhelper-compat, bump to 12.
  * control: Bump policy to 4.5.0.
  * Build with llvm-10, bump dependencies. (LP: #1871345)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 08 Apr 2020 22:55:41 +0300
